PROGRAM LibTest;

USES
     crt,
     dos,
     ml8bib,
     m049_lib;

VAR
   micro_slot: BYTE;
   srq_status: BYTE;
   srq_error : WORD;
   srq_handle: M049Handle;

(**************************************************************************)
(* Konvertierungsroutinen fr Hexadezimale Ausgabe ************************)
(**************************************************************************)

FUNCTION hex(zahl :LONGINT) : STRING;
  {wandelt eine beliebige LONGINT-Zahl in einen Hexadezimal-String}
VAR s : STRING[8];
    ziffer : Byte;
    w,wx   : WORD;
const
	HEXCONV : array [0..$F] of char = ('0','1','2','3','4','5','6','7',
					   '8','9','A','B','C','D','E','F');
BEGIN
  w:=0;
  REPEAT
    inc(w);
    s[w] := HEXCONV[BYTE(zahl) AND $F];
    zahl := zahl shr 4;
  UNTIL zahl=0;
  hex[0]:=char(w);
  wx:=1;
  FOR w:= w DOWNTO 1 DO BEGIN
    hex[w]:=s[wx];
    inc(wx);
  END;
END;

function BinToBcd(bin: BYTE): BYTE;
   var hn, ln: byte;
begin
   ln := bin mod 10;
   hn := bin div 10;
   bin := hn shl 4;
   BinToBcd := bin + ln;
end;

PROCEDURE gethex(val: byte; var hex:string);
	VAR i, j: byte;
	BEGIN

	hex[0] := '2';                        (* length of string *)
	j := val DIV 16;
	i := val MOD 16;
	IF(i < 10) THEN
  		hex[2] := chr(i + 48)
 	ELSE
  	BEGIN
   	i := i - 10;
   	hex[2] := chr(i + 65);
  	END;
   IF(j < 10) THEN
  		hex[1] := chr(j + 48)
 	ELSE
  	BEGIN
   	j := j - 10;
   	hex[1] := chr(j + 65);
  	END;
END;

PROCEDURE errorhandler; FAR;
BEGIN
	srq_error := ml8_get_message;
END;

PROCEDURE msg_service; FAR;
BEGIN
   srq_error := m049_evaluate_srq(micro_slot, srq_handle);
   srq_status := 1;
END;

VAR
   msg_par   : M049MsgType;
   osname    : str80;
   message1, message2, message3, message4: M049Handle;
	cfg_par   : M049ConfigType;
   i, d, size, status: BYTE;
   id        : LONGINT;
   empf_data : array[1..8] of BYTE;
   error     : WORD;
   data      : array[1..4] of WORD;
   send_data : array[1..8] of BYTE;

BEGIN
	osname := 'ROM';
   micro_slot := 3;
   srq_status := 0;
   srq_error := 0;
   srq_handle := 0;
   status := 0;
   d := 0;

	clrscr;
   ml8_bib_startup(LANGUAGE_PASCAL);
   error := ml8_reset(0, $380, 0, 7, 0, @errorhandler, osname, 100);
{   error := ml8_start(0, $380, 0, 7, 0, @errorhandler, 100);}
   if error <> 0 then
   begin
     	writeln(' Error ml8_reset: ',error);
		ml8_exit;
      exit;
   end;
   ml8_set_service(@msg_service);
   error := ml8_transfer_and_install('..\..\..\..\m049task\m049task.exe',0,20,
           M049TASK_PROG_NO, $7B, M049TASK_FLAGS,0);
   if error <> 0 then
   begin
     	writeln(' Error ml8_transfer_and_install: ',error);
		ml8_exit;
      exit;
   end;
   error := m049_bib_startup;
   if error <> 0 then
   begin
     	writeln(' Error m049_bib_startup: ',error);
		ml8_exit;
      exit;
   end;

   cfg_par.serv_task := 20;
   cfg_par.serv_func := 14;
   cfg_par.messages := 4;
   error := m049_config_module(micro_slot,cfg_par);
   if error <> 0 then
   begin
   	error := m049_get_diagnosis(micro_slot);
     	writeln(' Error m049_config_module: ',error);
		ml8_exit;
      exit;
   end;

	msg_par.id := $36;
	msg_par.control_flags := _M049_PASSIVE;
	msg_par.serv_task := 20;
	msg_par.serv_func := M049_SRQ_SERVICE_FUNC;
   error := m049_config_msg_object(micro_slot,message1,msg_par);
   if error <> 0 then
   begin
   	error := m049_get_diagnosis(micro_slot);
     	writeln(' Error m049_config_msg_object: ',error);
		ml8_exit;
      exit;
   end;
	msg_par.id := $37;
	msg_par.control_flags := _M049_ACTIVE + _M049_SEND;
	msg_par.serv_task := 20;
	msg_par.serv_func := M049_SRQ_SERVICE_FUNC;
   error := m049_config_msg_object(micro_slot,message2,msg_par);
   if error <> 0 then
   begin
   	error := m049_get_diagnosis(micro_slot);
     	writeln(' Error m049_config_msg_object: ',error);
		ml8_exit;
      exit;
   end;
	msg_par.id := $26;
	msg_par.control_flags := _M049_ACTIVE;
	msg_par.serv_task := 20;
	msg_par.serv_func := M049_SRQ_SERVICE_FUNC;
   error := m049_config_msg_object(micro_slot,message3,msg_par);
   if error <> 0 then
   begin
   	error := m049_get_diagnosis(micro_slot);
     	writeln(' Error m049_config_msg_object: ',error);
		ml8_exit;
      exit;
   end;
	msg_par.id := $27;
	msg_par.control_flags := _M049_ACTIVE + _M049_PASSIVE
	                         + _M049_SEND + _M049_EXCL_BUFFER;
	msg_par.serv_task := 20;
	msg_par.serv_func := M049_SRQ_SERVICE_FUNC;
   error := m049_config_msg_object(micro_slot,message4,msg_par);
   if error <> 0 then
   begin
   	error := m049_get_diagnosis(micro_slot);
     	writeln(' Error m049_config_msg_object: ',error);
		ml8_exit;
      exit;
   end;

   error := m049_start_com(micro_slot);
   if error <> 0 then
   begin
   	error := m049_get_diagnosis(micro_slot);
     	writeln(' Error m049_start_com: ',error);
		ml8_exit;
      exit;
   end;
	status := 0;

   while not KeyPressed do
   begin
      case status of
         0: begin
				GetTime(data[1], data[2], data[3], data[4]);
            for i:=1 to 4 do
            	send_data[i] := BinToBcd(BYTE(data[i]));
            error := m049_set_data(micro_slot,message2,send_data[1],4);
			   if error <> 0 then
			   begin
			   	error := m049_get_diagnosis(micro_slot);
			     	writeln(' Error m049_set_data: ',error);
					ml8_exit;
			      exit;
			   end;
            error := m049_send_data(micro_slot,message2);
			   if error <> 0 then
			   begin
			   	error := m049_get_diagnosis(micro_slot);
			     	writeln(' Error m049_send_data: ',error);
					ml8_exit;
			      exit;
			   end;
				status := 1;
            end;
         1: begin
            error := m049_send_data_request(micro_slot,message3);
			   if error <> 0 then
			   begin
			   	error := m049_get_diagnosis(micro_slot);
			     	writeln(' Error m049_send_data_request: ',error);
					ml8_exit;
			      exit;
			   end;
				status := 2;
            end;
         2: begin
            error := m049_set_data(micro_slot,message4,d,1);
			   if error <> 0 then
			   begin
			   	error := m049_get_diagnosis(micro_slot);
			     	writeln(' Error m049_set_data: ',error);
					ml8_exit;
			      exit;
			   end;
            if d < 255 then
               d := d + 1
            else
            	d := 0;
            error := m049_send_data(micro_slot,message4);
			   if error <> 0 then
			   begin
			   	error := m049_get_diagnosis(micro_slot);
			     	writeln(' Error m049_send_data: ',error);
					ml8_exit;
			      exit;
			   end;
				status := 0;
            end;
      end;
      delay(200);
      if srq_status <> 0 then
      begin
         if srq_handle <> 0 then
         begin
	    		write('Error = ',srq_error,'  handle = ', hex(srq_handle));
         	error := m049_get_id(micro_slot, srq_handle, id);
			   if error <> 0 then
			   begin
			   	error := m049_get_diagnosis(micro_slot);
			     	writeln(' Error m049_get_id: ',error);
					ml8_exit;
			      exit;
			   end;
         	size := 8;
         	error := m049_get_data(micro_slot, srq_handle, empf_data[1], size);
			   if error <> 0 then
			   begin
			   	error := m049_get_diagnosis(micro_slot);
			     	writeln(' Error m049_get_data: ',error);
					ml8_exit;
			      exit;
			   end;
           	write('  id = ',hex(id),'  data =');
            for i:=1 to size do
            begin
            	if empf_data[i] < 16 then
	           		write(' 0',hex(empf_data[i]))
               else
	           		write(' ',hex(empf_data[i]));
            end;
            writeln('');
         end;
	      srq_status := 0;
	   end
   else
		begin
      	if srq_error <> 0 then
         begin
		     	writeln(' Error Request: ', srq_error);
   	      ml8_clear;
      	   srq_status := 0;
            srq_error := 0;
         end;
      end;
   end;
END.