Attribute VB_Name = "M049_IMPORT_LIBRARY"
'*************************************************
'   M049_LIB.BAS
'
'   Import library to write Visual Basic programs
'   with the SORCUS module M-CAN-1
'
'   Operating Systems:  Windows 9x
'                       Windows NT
'
'   Author:             JD
'
'   (C) SORCUS Computer GmbH 1999
'*************************************************

Public Const M049TASK_PROG_NO = &H410
Public Const M049TASK_FLAGS = &HF8A
Public Const M049_TASK_ERROR = &H42
Public Const M049_INSTALL_ERROR = &H18
Public Const M049_SRQ_SERVICE_FUNC = 14

Public Const M049_INVALID_SLOT = &H226
Public Const M049_WRONG_PAR = &H228
Public Const M049_FUNC_NOT_IMPLEMENTED = &H223

Public Const M049_EXCL_BUFFER = &H1
Public Const M049_SEND = &H2
Public Const M049_ACTIVE = &H8
Public Const M049_PASSIVE = &H10
Public Const M049_DISABLE_INT = &H20

Public Type M049ConfigType
   messages    As Integer
   serv_task   As Integer
   serv_func   As Integer
End Type

' m049_lib_startup ... initializes this modul library.
Declare Function m049_bib_startup Lib "m049_lib.dll" () As Integer

' m049_config_module ... configures a modul
Declare Function m049_config_module Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByRef config As M049ConfigType) As Integer

' m049_create_msg_object ... configures a new Message object
Declare Function m049_create_msg_object Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByRef handle As Long, _
 ByVal id As Long, ByVal control_flags As Byte, _
 ByVal serv_task As Integer, ByVal serv_func As Integer) As Integer
 
' m049_start_com... starts the can communication
Declare Function m049_start_com Lib "m049_lib.dll" _
(ByVal micro_slot As Byte) As Integer

' m049_stop_com... stops the can communication
Declare Function m049_stop_com Lib "m049_lib.dll" _
(ByVal micro_slot As Byte) As Integer

' m049_set_data... set data in message object
Declare Function m049_set_data Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByVal handle As Long, _
 ByRef data As Byte, ByVal size As Byte) As Integer
 
' m049_get_data... get data of one message object data frame
Declare Function m049_get_data Lib "m049_lib.dll" _
 (ByVal micro_slot As Byte, ByVal handle As Long, _
 ByRef data As Byte, ByRef size As Byte) As Integer
 
' m049_send_data... transmits message object
Declare Function m049_send_data Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByVal handle As Long) As Integer

' m049_send_data_request... transmits message object remote frame
Declare Function m049_send_data_request Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByVal handle As Long) As Integer

' m049_clear_msg... deactivate message object
Declare Function m049_clear_msg Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByVal handle As Long) As Integer

' m049_set_acceptance_mask... filter messages in message buffer 15
Declare Function m049_set_acceptance_mask Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByRef mask As Long, ByVal usage As Byte, _
 ByVal serv_task As Integer, ByVal serv_func As Integer) As Integer

' m049_get_id... get the id of one message object
Declare Function m049_get_id Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByVal handle As Long, _
ByRef id_var As Long) As Integer

' m049_get_diagnosis... get error diagnosis
Declare Function m049_get_diagnosis Lib "m049_lib.dll" _
(ByVal micro_slot As Byte) As Integer

' m049_evaluate_srq... evaluates service request
Declare Function m049_evaluate_srq Lib "m049_lib.dll" _
(ByRef micro_slot As Byte, ByRef handle As Long) As Integer

' m049_get_dout... read state of one digital output
Declare Function m049_get_dout Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByVal nr As Byte) As Byte

' m049_set_dout... set one digital output
Declare Sub m049_set_dout Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByVal dout As Byte, ByVal data As Byte)

' m049_clear_configuration... clear message object configuration
Declare Function m049_clear_configuration Lib "m049_lib.dll" _
(ByVal micro_slot As Byte) As Integer

' m049_end_of_srq ... allow interrupt from module
Declare Sub m049_end_of_srq Lib "m049_lib.dll" _
(ByVal micro_slot As Byte)

' m049_enable_int_mask ... allow suspending of interrupt from module
Declare Sub m049_enable_int_mask Lib "m049_lib.dll" _
(ByVal micro_slot As Byte)

' m049_get_msg_count.. get the number of interrupts of one message object
Declare Function m049_get_msg_count Lib "m049_lib.dll" _
(ByVal micro_slot As Byte, ByVal handle As Long, _
 ByRef count As Long) As Integer

' m049_get_task_number.. get the number of m049task for this micro_slot
Declare Function m049_get_task_number Lib "m049_lib.dll" _
(ByVal micro_slot As Byte) As Integer

' m049_init_internal.. instead of m049_bib_startup if micro_slot=task number of M049TASK
Declare Sub m049_init_internal Lib "m049_lib.dll" ()

